//+------------------------------------------------------------------+
//|                                              stopreversal_ea.mq4 |
//+------------------------------------------------------------------+

extern double nPips = 0.004;
extern double Lots = 1;



int init()
{
   return(0);
}


int deinit()
{
   return(0);
}


int start()
{
   int cnt, ticket, total;
   int shift = 0;
   static int i;
   static double TrStopLevel;
   static double PREV;

   if(Close[shift] == PREV)
   {
      TrStopLevel = PREV;
      Print("a:", TrStopLevel);
   }
   else
   {
      if((Close[shift+1] < PREV) && (Close[shift+1] < PREV))
      {
         TrStopLevel = MathMin(PREV,Close[shift+1] * (1-nPips));
         Print("b:", TrStopLevel);
      }
      else
      {
         if (Close[shift] > PREV)
         {
            TrStopLevel = Close[shift] * (1-nPips);
            Print("c:", TrStopLevel);
         }
         else
         {
            TrStopLevel = Close[shift] * (1+nPips);
            Print("d:", TrStopLevel);
         }
      }
   }
   
   total  = OrdersTotal(); 
   if(total < 1) 
   {
      if ((Close[shift] > TrStopLevel) && (Close[shift+1] < PREV) && (PREV !=0))
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"SR",12345,0,Green);
         if(ticket>0)
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
               Print("BUY order opened : ",OrderOpenPrice());
         else 
            Print("Error opening BUY order : ",GetLastError());
         return(0);
      }
      
      if ((Close[shift] < TrStopLevel) && (Close[shift+1] > PREV) && (PREV!=0))
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"SR",12345,0,Red);
         if(ticket>0)
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
               Print("SELL order opened : ",OrderOpenPrice());
         else 
            Print("Error opening SELL order : ",GetLastError()); 
         return(0);
      }
   }
   
   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
         if(OrderType()==OP_BUY)   // long position is opened
            if ((Close[shift] < TrStopLevel) && (Close[shift+1] > PREV) && (PREV!=0))   
            {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
               return(0);
            }
      else // go to short position
      {
         if ((Close[shift] > TrStopLevel) && (Close[shift+1] < PREV) && (PREV !=0))
         {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
         }
      }   
   }   
   PREV = TrStopLevel;
   
   return(0);
}


